#!/usr/bin/perl
# Ce script en Perl fabrique des images via Rrdtool et la commande 
# "ntpdc -c rv 192.168.1.10" (exemple) 
# Necessite la lib suivante : "librrds-perl" + "rrdtool"
# A utiliser dans la crontab : 
# "0,10,20,30,40,50 * * * *	root	/opt/NTP-STATS/ntp-udp.pl localhost &"
# Ce script necessite 1 ou 2 repertoires, a vous de voir.
# Pour eviter l'installation de trop de dependance, pas de fonction "pod"... donc l'aide
# est livre a la fin de ce fin fichier (pas d'option à ce niveau).
########################################################## Ce script utilise ntpq
#
#
#
#
use strict ;
use RRDs;

# Le repertoire ou vont se trouver le programme + les graphes
# a laisser vide si le script est dans le repertoire ou sont traites les images/fichiers
# attention a la crontab (!) supporte pas le rep vide (!)
my $reptravail	= "/var/www/localhost/htdocs/ntpgraffe/scripts/" ;  
# a laisser vide si le script est dans le repertoire ou sont traites les images/fichiers
my $repdiff	= "/var/www/localhost/htdocs/ntpgraffe/scripts/" ;
# # ---- Nom de la base RRD
my @param = ();
$param[0] = $ARGV[0];
$param[1] = $reptravail ."rzo-".$ARGV[0] ;
$param[2] = $param[1] .".rrd"   ;
#--------------------------------------------------------------
my $version ="$0 version 2.0 (MARS 2010) sous licence (GPL)\n";
my ($heure, $minute, $jour, $mois, $an) = (localtime)[2,1,3,4,5];#
    $an += 1900 ;
    $mois += 1 ;

if (length($heure) == 1) 	{ $heure   = "0" .$heure; }
if (length($minute) == 1) 	{ $minute = "0" .$minute; }
if (length($mois) == 1) 	{ $mois     = "0" .$mois; }

$param[3] = "$jour/$mois/$an $heure"."H"."$minute";
# $param[3] = "$jour $mois $an $heure". "H". "$minute";

use vars qw ($i $cmd $rec $create $option $test $name $fichier) ;

#-------------- Fin PARTIE CONFIGURABLE VARIABLES ---------------
#-------------- Fonction-CREATE RRDs (1) --
sub create_rrd {
# 4 valeurs - Valeur MAX demandee
#DS:Local:GAUGE:600:0:U pour type GAUGE toutes les 300s(5 mn)
# si pas de donnee au bout de 600s valeur RRA = 0.
	RRDs::create ($_[0] , 
		"--step","600",
		"DS:rec:GAUGE:1200:0:U",
		"DS:pro:GAUGE:1200:0:U",
		"DS:dec:GAUGE:1200:0:U",
		"DS:den:GAUGE:1200:0:U",
		"DS:aut:GAUGE:1200:0:U",
		
		"RRA:AVERAGE:0.5:1:600",
		"RRA:AVERAGE:0.5:1:1200",
		"RRA:AVERAGE:0.5:5:2400",

		"RRA:LAST:0.5:1:1200",

		"RRA:MAX:0.5:12:1200"
	);

	if (RRDs::error) {
	print RRDs::error ."\nImpossible de creer le fichier RRD `$_[0]'\n" ;
	exit(1);
	} else { print "Creation du fichier RRD `$_[0]' = [Ok]\n" ; }
exit(1);
}
#-------------- Fin fonction---------------
sub MiseAJour {
# Fonction avec X passages de parametres via les $_...
# ("0-UDP"-->$_[0], 
# $serveur,
# 2-$fich_RRD,
# 3-$type-->$_[1]
# 3-$received, 5-$processed, $declined, 
# 7-$denied, $format, 9-$authentication, $exceeded) 11=$majtime  ;
# 0 = "offset"   1 = $serveur   2 = $fichierR
# 3 =  $type     4 = $offset
# 5 =  $majtime  6 = nom-du-fichier-png;
#

my $RefTab = $_[2];
my @Param = @$RefTab;
# 2eme tableau :
my $RefTab = $_[3];
my @rCMD = @$RefTab;

my $fich_png ; my $lign ;
my $xpts 	= 517;
my $ypts 	= 273;
my @typegraph = (
                { titre => '24H',       decal => '24h',},
                { titre => 'Semaine',   decal => '7d' ,},
                { titre => 'Mois',      decal => '30d' ,},
                { titre => '6 mois',    decal => '180d' ,},
                );

if ($_[1] == 0 ) { $fich_png = $Param[1]."-J.png" ; $lign="LINE1";  }
if ($_[1] == 1 ) { $fich_png = $Param[1]."-S.png" ; $lign="LINE0";  }
if ($_[1] == 2 ) { $fich_png = $Param[1]."-M.png" ; $lign="LINE0";  }
if ($_[1] == 3 ) { $fich_png = $Param[1]."-A.png" ; $lign="LINE1";  }

my %color = ( 
	a => "3CE63C",   # vert
	b => "FFC000",   # orange
	c => "D0ECFF",   # jaune clair
	d => "A800FF",   # bleu fonce
	e => "0008FF",   # bleu
	f => "18C900",   # vert fonce
	g => "FF0000",   # rouge
	h => "ffc4c4",   # rouge clair
	i => "010101",   # noir

	j => "8E8E8E",    #Fond gris
	k => "000000",    #Trais noirs
	l => "E5F6FF"     #contour bleue
	
	);

my $title	= "NTP-($_[0])-$Param[0]-".$typegraph[$_[1]]{titre} ;

		RRDs::graph ( $fich_png,
		"--imgformat=PNG",		# ou GIF
		"--start", "-$typegraph[$_[1]]{decal}",
		"--alt-autoscale",
		"--width","$xpts",
		"--height","$ypts",
		"--rigid",
		"--title", " $title",
		"--vertical-label","<--Paquets UDP-->",
		"--color","SHADEA#$color{j}",
		"--color","SHADEB#$color{k}",
		"--color","BACK#$color{c}"  ,

		"DEF:Arec=$Param[2]:rec:LAST",
		"DEF:Apro=$Param[2]:pro:LAST",
		"DEF:Adec=$Param[2]:dec:LAST",
		"DEF:Aden=$Param[2]:den:LAST",
		"DEF:Aaut=$Param[2]:aut:LAST",
	
		"DEF:Mrec=$Param[2]:rec:MAX",
		"DEF:Mpro=$Param[2]:pro:MAX",
		"DEF:Mdec=$Param[2]:dec:MAX",
		"DEF:Mden=$Param[2]:den:MAX",
		"DEF:Maut=$Param[2]:aut:MAX",

		"AREA:Arec#$color{b}:RECU  :",
		$lign.":Arec#$color{k}:",	
		'GPRINT:Arec:LAST: %12.0lf',
		'GPRINT:Mrec:MAX:Max \: %12.0lf \\n',
		
		"AREA:Apro#$color{f}:PROC  :",
		$lign.":Apro#$color{k}:",	
		'GPRINT:Apro:LAST: %12.0lf',
		'GPRINT:Mpro:MAX:Max \: %12.0lf \\n',
		
		"AREA:Adec#$color{d}:DECLI :",
		$lign.":Adec#$color{k}:",	
		'GPRINT:Adec:LAST: %12.0lf',
		'GPRINT:Mdec:MAX:Max \: %12.0lf \\n',
	
		"AREA:Aden#$color{e}:DENIED:",
		$lign.":Aden#$color{k}:",	
		'GPRINT:Aden:LAST: %12.0lf',
		'GPRINT:Mden:MAX:Max \: %12.0lf \\n',
		
		"AREA:Aaut#$color{g}:AUTH  :",
		$lign.":Aaut#$color{k}:",	
		'GPRINT:Aaut:LAST: %12.0lf',
		'GPRINT:Maut:MAX:Max \: %12.0lf \\n',
	
		"COMMENT:Nbr_FORMAT @rCMD[5] \\n",
		"COMMENT:Nbr_DEPASS @rCMD[9] \\n",
		"COMMENT:                    Mise a jour le $Param[3] \\n"
	);	
		if (RRDs::error) { print RRDs::error ;
			   print "\nERREUR avec RRDs et $fich_png\n " ;
	 	}
}

# ----------------------------------------------------------------------
	# Si le fichier .rrd n est pas present ...
	if (not -f $param[2]) { create_rrd($param[2]) ; }
#-------------------------------------------------

# Lancement de la commande :
my @retourCMD ;
$cmd = `ntpq -c sysstats $ARGV[0]`;
# $cmd = `ntpdc -c sysstats 127.0.0.1`; #  peut servir (...)

   if (!$cmd) { print "Probleme avec ntpq...(NTPD est il actif(?)\n" ; exit(1) ; } 

   $cmd =~ s/\n/#/g ;           # passage sur 1 ligne entiere, pour traitement ensuite
   $cmd =~ s/\s//g ;           # suppression des espaces 
   $cmd =~ s/[a-zA-Z:]//g ;           # suppression des espaces 
   @retourCMD = $cmd ;

	# extraction des donnees :
	@retourCMD = split(/#/, $cmd);
	
	#  doit ressembler a ca desormais
	#O->uptime:2298 1-sysstatsreset:2297 2->packetsreceived:264 
	#3->currentversion:202 4->olderversion:0
	#5-> badlengthorformat:0 6->authenticationfailed:0 7->declined:0
	#8-> restricted:0 9->ratelimited:0 10->KoDresponses:0
	#11-> processedfortime:164
	
	@retourCMD[2] =~ s/(\d+)/$1/ ; # recu REC (1)
	@retourCMD[8] =~ m/\d+/ ; # RESTRICT (4)
	@retourCMD[5] =~ m/\d+/ ; # bad lenght/format (6)
	@retourCMD[6] =~ m/\d+/ ; # AUTH bad authentification (5)
	@retourCMD[7] =~ m/\d+/ ; # DECLI rejete (3)
	@retourCMD[9] =~ m/\d+/ ; # depasse(rate) (7)
	@retourCMD[11] =~ s/(\d+)/$1/ ; # traite PROC (2)

#----------------------------------------------------------
# Mise a jour des donnees - journee/semaine/mois/annee (type)

# insertion des donnees dans le fichier RRD :
RRDs::update $param[2],"N:@retourCMD[2]:@retourCMD[11]:@retourCMD[7]:@retourCMD[8]:@retourCMD[6]:@retourCMD[5]:@retourCMD[9]";
if (RRDs::error) { print "RRDs::error Mise a jour impossible de $param[2]\n"; }

my $type = 0;
# 
if (( $minute >= "0" ) and ( $minute < "4" )) {      
	while ($type < 4) {

		# toutes les heures mets a jour TOUT
		MiseAJour ("UDP", $type, \@param, \@retourCMD ) ;
		
		$type++ ;
		} 
} else {
	        # ne mets a jour que le graphe "journalier" 
		MiseAJour ("UDP", "0", \@param, \@retourCMD ) ;

}

# ET FIN ...........

